//
//  TableViewController.swift
//  Goner
//
//  Created by Mark Meretzky on 12/27/14.
//  Copyright (c) 2014 Mark Meretzky. All rights reserved.
//

import UIKit

class TableViewController: UITableViewController {
	let cellReuseIdentifier: String = "characters";

	var characters: [String] = [
		"Scarlett O’Hara",	//apostrophe: Unicode \u2019
		"Rhett Butler",
		"Ashley Wilkes",
		"Melanie Hamilton",
		"Scarlett’s father",
		"Scarlett’s mother",
		"Mammy (Scarlett’s slave)",
		"Big Sam (Scarlett’s slave)",
		"Charles Hamilton (1st husband)",
		"Frank Kennedy (2nd husband)",
		"Bonnie Butler (S’s daughter)",
		"Belle Watling"
	];

	//Called from the application delegate.

	override init(style: UITableViewStyle) {
		super.init(style: style);
	}

	//Called from the above method.

	override init(nibName: String?, bundle: NSBundle?) {
		super.init(nibName: nibName, bundle: bundle);
	}

	//not called
	required init(coder aDecoder: NSCoder) {
		super.init(nibName: nil, bundle: nil);
	}

	override func viewDidLoad() {
		super.viewDidLoad();
		tableView.registerClass(UITableViewCell.self, forCellReuseIdentifier: cellReuseIdentifier);

		// Uncomment the following line to preserve selection between presentations
		// clearsSelectionOnViewWillAppear = false;

		// Uncomment the following line to display an Edit button in the navigation bar for this view controller.
		navigationItem.rightBarButtonItem = editButtonItem();
	}

	override func didReceiveMemoryWarning() {
		super.didReceiveMemoryWarning()
		// Dispose of any resources that can be recreated.
	}

	// MARK: - Table view data source

	override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
		// Return the number of sections.
		return 1;
	}

	override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
		// Return the number of rows in the section.
		return characters.count;
	}

	override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
		let cell: UITableViewCell =
			tableView.dequeueReusableCellWithIdentifier(cellReuseIdentifier, forIndexPath: indexPath) as UITableViewCell;

		// Configure the cell...
		cell.textLabel!.text = characters[indexPath.row];
		return cell;
	}

	/*
	// Override to support conditional editing of the table view.
	override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
		// Return false if you do not want the specified item to be editable.
		return true;
	}
	*/

	// Override to support editing the table view.
    override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
		if editingStyle == .Delete {
			// Delete the row from the data source
			characters.removeAtIndex(indexPath.row);
			tableView.deleteRowsAtIndexPaths([indexPath], withRowAnimation: UITableViewRowAnimation.Fade);
		} else if editingStyle == .Insert {
			// Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
		}
	}

	/*
	// Override to support rearranging the table view.
	override func tableView(tableView: UITableView, moveRowAtIndexPath fromIndexPath: NSIndexPath, toIndexPath: NSIndexPath) {

	}
	*/

	/*
	// Override to support conditional rearranging of the table view.
	override func tableView(tableView: UITableView, canMoveRowAtIndexPath indexPath: NSIndexPath) -> Bool {
		// Return false if you do not want the item to be re-orderable.
		return true;
	}
	*/

	/*
	// MARK: - Navigation

	// In a storyboard-based application, you will often want to do a little preparation before navigation
	override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
		// Get the new view controller using [segue destinationViewController].
		// Pass the selected object to the new view controller.
	}
	*/

}
